<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: exampleMocoTrack.py</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_developer.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For C++ developers</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('exampleMocoTrack_8py-example.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">exampleMocoTrack.py</div>  </div>
</div><!--header-->
<div class="contents">
<p>This is an example using the MocoTrack tool with a complex model to track walking.</p>
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment"># -------------------------------------------------------------------------- #</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"># OpenSim Moco: exampleMocoTrack.py                                          #</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"># -------------------------------------------------------------------------- #</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"># Copyright (c) 2019 Stanford University and the Authors                     #</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">#                                                                            #</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"># Author(s): Nicholas Bianco                                                 #</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment">#                                                                            #</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"># Licensed under the Apache License, Version 2.0 (the &quot;License&quot;) you may     #</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"># not use this file except in compliance with the License. You may obtain a  #</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"># copy of the License at http://www.apache.org/licenses/LICENSE-2.0          #</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment">#                                                                            #</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"># Unless required by applicable law or agreed to in writing, software        #</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"># distributed under the License is distributed on an &quot;AS IS&quot; BASIS,          #</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"># WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   #</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"># See the License for the specific language governing permissions and        #</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"># limitations under the License.                                             #</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"># -------------------------------------------------------------------------- #</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160; </div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"># This example features two different tracking problems solved using the</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"># MocoTrack tool. </span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment">#  - The first problem demonstrates the basic usage of the tool interface</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment">#    to solve a torque-driven marker tracking problem. </span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment">#  - The second problem shows how to customize a muscle-driven state tracking </span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment">#    problem using more advanced features of the tool interface.</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment"># </span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment"># See the README.txt next to this file for more information.</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160; </div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="keyword">import</span> os</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="keyword">import</span> opensim <span class="keyword">as</span> osim</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160; </div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="keyword">def </span>torqueDrivenMarkerTracking():</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160; </div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    <span class="comment"># Create and name an instance of the MocoTrack tool.</span></div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    track = osim.MocoTrack()</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    track.setName(<span class="stringliteral">&quot;torque_driven_marker_tracking&quot;</span>)</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160; </div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <span class="comment"># Construct a ModelProcessor and add it to the tool. ModelProcessors</span></div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    <span class="comment"># accept a base model and allow you to easily modify the model by appending</span></div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    <span class="comment"># ModelOperators. Operations are performed in the order that they are</span></div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <span class="comment"># appended to the model.</span></div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <span class="comment"># Create the base Model by passing in the model file.</span></div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    modelProcessor = osim.ModelProcessor(<span class="stringliteral">&quot;subject_walk_armless.osim&quot;</span>)</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    <span class="comment"># Add ground reaction external loads in lieu of a ground-contact model.</span></div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    modelProcessor.append(osim.ModOpAddExternalLoads(<span class="stringliteral">&quot;grf_walk.xml&quot;</span>))</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    <span class="comment"># Remove all the muscles in the model&#39;s ForceSet.</span></div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    modelProcessor.append(osim.ModOpRemoveMuscles())</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <span class="comment"># Add CoordinateActuators to the model degrees-of-freedom. This ignores the </span></div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <span class="comment"># pelvis coordinates which already have residual CoordinateActuators.</span></div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    modelProcessor.append(osim.ModOpAddReserves(250))</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    track.setModel(modelProcessor)</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160; </div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    <span class="comment"># Use this convenience function to set the MocoTrack markers reference</span></div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <span class="comment"># directly from a TRC file. By default, the markers data is filtered at</span></div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="comment"># 6 Hz and if in millimeters, converted to meters.</span></div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    track.setMarkersReferenceFromTRC(<span class="stringliteral">&quot;marker_trajectories.trc&quot;</span>)</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160; </div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <span class="comment"># There is marker data in the &#39;marker_trajectories.trc&#39; associated with</span></div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <span class="comment"># model markers that no longer exists (i.e. markers on the arms). Set this</span></div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <span class="comment"># flag to avoid an exception from being thrown.</span></div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    track.set_allow_unused_references(<span class="keyword">True</span>)</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160; </div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    <span class="comment"># Increase the global marker tracking weight, which is the weight</span></div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    <span class="comment"># associated with the internal MocoMarkerTrackingCost term.</span></div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    track.set_markers_global_tracking_weight(10)</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160; </div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <span class="comment"># Increase the tracking weights for individual markers in the data set </span></div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    <span class="comment"># placed on bony landmarks compared to markers located on soft tissue.</span></div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    markerWeights = osim.MocoWeightSet()</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    markerWeights.cloneAndAppend(osim.MocoWeight(<span class="stringliteral">&quot;R.ASIS&quot;</span>, 20))</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    markerWeights.cloneAndAppend(osim.MocoWeight(<span class="stringliteral">&quot;L.ASIS&quot;</span>, 20))</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    markerWeights.cloneAndAppend(osim.MocoWeight(<span class="stringliteral">&quot;R.PSIS&quot;</span>, 20))</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    markerWeights.cloneAndAppend(osim.MocoWeight(<span class="stringliteral">&quot;L.PSIS&quot;</span>, 20))</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    markerWeights.cloneAndAppend(osim.MocoWeight(<span class="stringliteral">&quot;R.Knee&quot;</span>, 10))</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    markerWeights.cloneAndAppend(osim.MocoWeight(<span class="stringliteral">&quot;R.Ankle&quot;</span>, 10))</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    markerWeights.cloneAndAppend(osim.MocoWeight(<span class="stringliteral">&quot;R.Heel&quot;</span>, 10))</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    markerWeights.cloneAndAppend(osim.MocoWeight(<span class="stringliteral">&quot;R.MT5&quot;</span>, 5))</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    markerWeights.cloneAndAppend(osim.MocoWeight(<span class="stringliteral">&quot;R.Toe&quot;</span>, 2))</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    markerWeights.cloneAndAppend(osim.MocoWeight(<span class="stringliteral">&quot;L.Knee&quot;</span>, 10))</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    markerWeights.cloneAndAppend(osim.MocoWeight(<span class="stringliteral">&quot;L.Ankle&quot;</span>, 10))</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    markerWeights.cloneAndAppend(osim.MocoWeight(<span class="stringliteral">&quot;L.Heel&quot;</span>, 10))</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    markerWeights.cloneAndAppend(osim.MocoWeight(<span class="stringliteral">&quot;L.MT5&quot;</span>, 5))</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    markerWeights.cloneAndAppend(osim.MocoWeight(<span class="stringliteral">&quot;L.Toe&quot;</span>, 2))</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    track.set_markers_weight_set(markerWeights)</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160; </div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    <span class="comment"># Initial time, final time, and mesh interval. The number of mesh points</span></div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    <span class="comment"># used to discretize the problem is computed internally using these values.</span></div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    track.set_initial_time(0.81)</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    track.set_final_time(1.65)</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    track.set_mesh_interval(0.05)</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160; </div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    <span class="comment"># Solve! Use track.solve() to skip visualizing.</span></div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    solution = track.solveAndVisualize()</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160; </div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;<span class="keyword">def </span>muscleDrivenStateTracking():</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160; </div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    <span class="comment"># Create and name an instance of the MocoTrack tool.</span></div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    track = osim.MocoTrack()</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    track.setName(<span class="stringliteral">&quot;muscle_driven_state_tracking&quot;</span>)</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160; </div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;    <span class="comment"># Construct a ModelProcessor and set it on the tool. The default</span></div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    <span class="comment"># muscles in the model are replaced with optimization-friendly</span></div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;    <span class="comment"># DeGrooteFregly2016Muscles, and adjustments are made to the default muscle</span></div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    <span class="comment"># parameters.</span></div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;    modelProcessor = osim.ModelProcessor(<span class="stringliteral">&quot;subject_walk_armless.osim&quot;</span>)</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    modelProcessor.append(osim.ModOpAddExternalLoads(<span class="stringliteral">&quot;grf_walk.xml&quot;</span>))</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;    modelProcessor.append(osim.ModOpIgnoreTendonCompliance())</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;    modelProcessor.append(osim.ModOpReplaceMusclesWithDeGrooteFregly2016())</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;    <span class="comment"># Only valid for DeGrooteFregly2016Muscles.</span></div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;    modelProcessor.append(osim.ModOpIgnorePassiveFiberForcesDGF())</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;    <span class="comment"># Only valid for DeGrooteFregly2016Muscles.</span></div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    modelProcessor.append(osim.ModOpScaleActiveFiberForceCurveWidthDGF(1.5))</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;    track.setModel(modelProcessor)</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160; </div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;    <span class="comment"># Construct a TableProcessor of the coordinate data and pass it to the </span></div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;    <span class="comment"># tracking tool. TableProcessors can be used in the same way as</span></div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;    <span class="comment"># ModelProcessors by appending TableOperators to modify the base table.</span></div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    <span class="comment"># A TableProcessor with no operators, as we have here, simply returns the</span></div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;    <span class="comment"># base table.</span></div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    track.setStatesReference(osim.TableProcessor(<span class="stringliteral">&quot;coordinates.sto&quot;</span>))</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    track.set_states_global_tracking_weight(10)</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160; </div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    <span class="comment"># This setting allows extra data columns contained in the states</span></div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;    <span class="comment"># reference that don&#39;t correspond to model coordinates.</span></div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;    track.set_allow_unused_references(<span class="keyword">True</span>)</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160; </div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;    <span class="comment"># Since there is only coordinate position data in the states references,</span></div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;    <span class="comment"># this setting is enabled to fill in the missing coordinate speed data using</span></div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;    <span class="comment"># the derivative of splined position data.</span></div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;    track.set_track_reference_position_derivatives(<span class="keyword">True</span>)</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160; </div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;    <span class="comment"># Initial time, final time, and mesh interval.</span></div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;    track.set_initial_time(0.81)</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;    track.set_final_time(1.65)</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;    track.set_mesh_interval(0.08)</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160; </div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;    <span class="comment"># Instead of calling solve(), call initialize() to receive a pre-configured</span></div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;    <span class="comment"># MocoStudy object based on the settings above. Use this to customize the</span></div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;    <span class="comment"># problem beyond the MocoTrack interface.</span></div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;    study = track.initialize()</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160; </div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;    <span class="comment"># Get a reference to the MocoControlCost that is added to every MocoTrack</span></div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;    <span class="comment"># problem by default.</span></div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;    problem = study.updProblem()</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;    effort = osim.MocoControlGoal.safeDownCast(problem.updGoal(<span class="stringliteral">&quot;control_effort&quot;</span>))</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160; </div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;    <span class="comment"># Put a large weight on the pelvis CoordinateActuators, which act as the</span></div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;    <span class="comment"># residual, or &#39;hand-of-god&#39;, forces which we would like to keep as small</span></div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;    <span class="comment"># as possible.</span></div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;    model = modelProcessor.process()</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;    model.initSystem()</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;    forceSet = model.getForceSet()</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;    <span class="keywordflow">for</span> i <span class="keywordflow">in</span> range(forceSet.getSize()):</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;        forcePath = forceSet.get(i).getAbsolutePathString()</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;        <span class="keywordflow">if</span> <span class="stringliteral">&#39;pelvis&#39;</span> <span class="keywordflow">in</span> str(forcePath):</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;            effort.setWeightForControl(forcePath, 10)</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;    </div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;    <span class="comment"># Solve and visualize.</span></div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;    solution = study.solve()</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;    study.visualize(solution)</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160; </div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;<span class="comment"># Solve the torque-driven marker tracking problem.</span></div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;<span class="comment"># This problem takes a few minutes to solve.</span></div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;torqueDrivenMarkerTracking()</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160; </div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;<span class="comment"># Solve the muscle-driven state tracking problem.</span></div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;<span class="comment"># This problem could take an hour or more to solve, depending on the number of</span></div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;<span class="comment"># processor cores available for parallelization. With 12 cores, it takes around</span></div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;<span class="comment"># 25 minutes.</span></div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;muscleDrivenStateTracking()</div>
</div><!-- fragment --> </div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:01 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
